﻿using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            #region 이동 변환을 생성한다.

            TranslateTransform translateTransform = new TranslateTransform();

            #endregion
            #region 사각형을 생성한다.

            Rectangle rectangle = new Rectangle();

            rectangle.Width           = 50;
            rectangle.Height          = 50;
            rectangle.StrokeThickness = 5;
            rectangle.Stroke          = Brushes.Black;
            rectangle.Fill            = Brushes.Red;
            rectangle.RenderTransform = translateTransform;

            #endregion
            #region 이동 변환 애니메이션을 생성한다.

            DoubleAnimationUsingKeyFrames translateTransformAnimation =    new DoubleAnimationUsingKeyFrames();

            translateTransformAnimation.Duration = TimeSpan.FromSeconds(10);

            translateTransformAnimation.KeyFrames.Add(new LinearDoubleKeyFrame(100, KeyTime.Uniform));
            translateTransformAnimation.KeyFrames.Add(new LinearDoubleKeyFrame(200, KeyTime.Uniform));
            translateTransformAnimation.KeyFrames.Add(new LinearDoubleKeyFrame(300, KeyTime.Uniform));

            #endregion

            rectangle.Loaded += delegate(object sender, RoutedEventArgs e)
            {
                translateTransform.BeginAnimation(TranslateTransform.XProperty, translateTransformAnimation);
            };

            Content = rectangle;
        }

        #endregion
    }
}